commit 739a64d44685ec3b66999652d52aed4707114326
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Tue Feb 28 17:30:36 2023 +0100

    Beginnings of Skewb Diamond solver.

diff --git a/src/main/java/org/distorted/objectlib/tablebases/ImplementedTablebasesList.java b/src/main/java/org/distorted/objectlib/tablebases/ImplementedTablebasesList.java
index 2445bf00..c11deb8f 100644
--- a/src/main/java/org/distorted/objectlib/tablebases/ImplementedTablebasesList.java
+++ b/src/main/java/org/distorted/objectlib/tablebases/ImplementedTablebasesList.java
@@ -24,6 +24,7 @@ public enum ImplementedTablebasesList
   IVY_CUBE      (ObjectType.IVY_2 , TablebasesIvyCube.class),
   CU_232        (ObjectType.CU_232, TablebasesCuboid232.class),
   PYRA_3        (ObjectType.PYRA_3, TablebasesPyraminx.class),
+  DIAMOND       (ObjectType.DIAM_2, TablebasesSkewbDiamond.class),
   ;
 
   public static final int NUM_OBJECTS = values().length;
diff --git a/src/main/java/org/distorted/objectlib/tablebases/TablebasesSkewbDiamond.java b/src/main/java/org/distorted/objectlib/tablebases/TablebasesSkewbDiamond.java
new file mode 100644
index 00000000..7a836dc1
--- /dev/null
+++ b/src/main/java/org/distorted/objectlib/tablebases/TablebasesSkewbDiamond.java
@@ -0,0 +1,106 @@
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// Copyright 2023 Leszek Koltunski                                                               //
+//                                                                                               //
+// This file is part of Magic Cube.                                                              //
+//                                                                                               //
+// Magic Cube is proprietary software licensed under an EULA which you should have received      //
+// along with the code. If not, check https://distorted.org/magic/License-Magic-Cube.html        //
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+package org.distorted.objectlib.tablebases;
+
+import static org.distorted.objectlib.main.TwistyObject.SQ3;
+import static org.distorted.objectlib.main.TwistyObject.SQ6;
+
+import android.content.res.Resources;
+
+import org.distorted.library.type.Static3D;
+import org.distorted.objectlib.R;
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+public class TablebasesSkewbDiamond extends TablebasesAbstract
+{
+  public TablebasesSkewbDiamond()
+    {
+    super();
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public TablebasesSkewbDiamond(Resources res)
+    {
+    super(res, R.raw.pyra_3_tablebase);
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  int[][] getBasicAngles()
+    {
+    int[] tmp = {3,3};
+    return new int[][] { tmp,tmp,tmp,tmp };
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  Static3D[] getRotationAxis()
+    {
+    return new Static3D[]
+         {
+           new Static3D( SQ6/3, SQ3/3,     0),
+           new Static3D(-SQ6/3, SQ3/3,     0),
+           new Static3D(     0,-SQ3/3,-SQ6/3),
+           new Static3D(     0,-SQ3/3, SQ6/3)
+         };
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  float[][] getPosition()
+    {
+    return new float[][]
+         {
+            // TODO
+         };
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  float[][] getCuts()
+    {
+    float[] cut = { 0.0f };
+    return new float[][] { cut,cut,cut,cut };
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  boolean[][] getRotatable()
+    {
+    boolean[] tmp = new boolean[] {false,true};
+    return new boolean[][] { tmp,tmp,tmp,tmp };
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+// specifically for the tablebase
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  int getSize()
+    {
+    return 138240;  // see https://www.jaapsch.net/puzzles/diamond.htm
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int[] getQuats(int index)
+    {
+    return null;
+    }
+
+///////////////////////////////////////////////////////////////////////////////////////////////////
+
+  public int getIndex(int[] quats)
+    {
+    return 0;
+    }
+}  
+